#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

static char initstate[] = {
#if 0
  "         "
  "   ***   "
  "   ***   "
  " ******* "
  " ***o*** "
  " ******* "
  "   ***   "
  "   ***   "
  "         "
#endif
#if 0
  "  *****  "
  "  *****  "
  "*********"
  "*********"
  "****o****"
  "*********"
  "*********"
  "  *****  "
  "  *****  "
#endif
  "***   ***"
  "***   ***"
  "*********"
  "  *****  "
  "  **o**  "
  "  *****  "
  "*********"
  "***   ***"
  "***   ***"};


#define cell(s,x,y) (s[(y)*9+(x)])

#define empty ' '
#define full  '*'
#define hole  'o'


static int min_score=81;


int solve(char *state, int depth)
{
  int x,y,m=0,moves=0;
  int randmoves[4];

  /* Print the board */

  /*printf("\033[2J\033[H");*/
  for(y=0;y<9;y++){
    for(x=0;x<9;x++){
      if(cell(state,x,y)==full)m++;
      /*putchar(cell(state,x,y));*/
    }
    /*putchar('\n');*/
  }

  if(m<min_score){
    min_score=m;
    printf("\nBest score so far: %d\nDepth: %d\n",min_score,depth);
  }


  /* Is the game solved? */

  if(m==1)return 1;


  /* Randomize move table */

  randmoves[0]=(rand()>>10)&3;
  for(x=1;x<4;x++) randmoves[x]=(randmoves[x-1]+1)%4;


  /* Make all possible moves at this stage */

  moves=0;
  for(y=0;y<9;y++){
    for(x=0;x<9;x++){
      if(cell(state,x,y)==full){
	for(m=0;m<4;m++){
	  switch(m){
	  case 0:
	    
	    /* Move to the left */
	    if(x>1){
	      if((cell(state,x-1,y)==full) &&
		 (cell(state,x-2,y)==hole)){
		char new_state[81];
		strcpy(new_state,state);
		moves++;
		cell(new_state,x  ,y)=hole;
		cell(new_state,x-1,y)=hole;
		cell(new_state,x-2,y)=full;
		if(solve(new_state,depth+1))return 1;
	      }
	    }
	    break;

	  case 1:

	    /* Move to the right */
	    if(x<7){
	      if((cell(state,x+1,y)==full) &&
		 (cell(state,x+2,y)==hole)){
		char new_state[81];
		strcpy(new_state,state);
		moves++;
		cell(new_state,x  ,y)=hole;
		cell(new_state,x+1,y)=hole;
		cell(new_state,x+2,y)=full;
		if(solve(new_state,depth+1))return 1;
	      }
	    }
	    break;

	  case 2:
	    /* Move up */
	    if(y>1){
	      if((cell(state,x,y-1)==full) &&
		 (cell(state,x,y-2)==hole)){
		char new_state[81];
		strcpy(new_state,state);
		moves++;
		cell(new_state,x,y  )=hole;
		cell(new_state,x,y-1)=hole;
		cell(new_state,x,y-2)=full;
		if(solve(new_state,depth+1))return 1;
	      }
	    }
	    break;

	  case 3:
	    /* Move down */
	    if(y<7){
	      if((cell(state,x,y+1)==full) &&
		 (cell(state,x,y+2)==hole)){
		char new_state[81];
		strcpy(new_state,state);
		moves++;
		cell(new_state,x,y  )=hole;
		cell(new_state,x,y+1)=hole;
		cell(new_state,x,y+2)=full;
		if(solve(new_state,depth+1))return 1;
	      }
	    }
	  }
	}
      }
    }
  }
  /*printf("Moves: %d\n",moves);*/

  return 0;
}



int
main()
{
  srand(time(0)|getpid());
  if(solve(initstate,1)) printf("\n\nGame is solvable\n");
  return 0;
}
